import sys, os, os.path, soya, soya.sdlconst
soya.init()
soya.path.append(os.path.join(os.path.dirname(sys.argv[0]), "data"))
soya.set_quality(2)
scene = soya.World()
terrain = soya.Terrain(scene)
terrain.from_image(soya.Image.get("map1.png"))
terrain.multiply_height(8.0)
material1 = soya.Material.get("block2")
material2 = soya.Material.get("metal1")
terrain.set_material_layer(material1, 0.0, 6.0)
terrain.set_material_layer(material2, 6.0, 8.0)
terrain.set_material_layer_angle(material1, 0.0, 8.0, 0.0, 20.0)
terrain.texture_factor = 1.0
terrain.scale_factor   = 1.0
terrain.patch_size     = 8
terrain.split_factor   = 2.0
terrain.texture_factor = 0.25
terrain.y = -2.5
light = soya.Light(scene)
light.set_xyz(0.0, 15.0, 0.0)
class MovableCamera(soya.Camera):
	def __init__(self, parent):
		soya.Camera.__init__(self, parent)
		self.speed = soya.Vector(self)
		self.rotation_y_speed = 0.0
		self.rotation_x_speed = 0.0
	def begin_round(self):
		soya.Camera.begin_round(self)
		for event in soya.process_event():
			if event[0] == soya.sdlconst.KEYDOWN:
				if   event[1] == soya.sdlconst.K_UP:     self.speed.z = -1.0
				elif event[1] == soya.sdlconst.K_DOWN:   self.speed.z =  1.0
				elif event[1] == soya.sdlconst.K_LEFT:   self.rotation_y_speed =  10.0
				elif event[1] == soya.sdlconst.K_RIGHT:  self.rotation_y_speed = -10.0
				elif event[1] == soya.sdlconst.K_q:      soya.MAIN_LOOP.stop()
				elif event[1] == soya.sdlconst.K_ESCAPE: soya.MAIN_LOOP.stop()
			if event[0] == soya.sdlconst.KEYUP:
				if   event[1] == soya.sdlconst.K_UP:     self.speed.z = 0.0
				elif event[1] == soya.sdlconst.K_DOWN:   self.speed.z = 0.0
				elif event[1] == soya.sdlconst.K_LEFT:   self.rotation_y_speed = 0.0
				elif event[1] == soya.sdlconst.K_RIGHT:  self.rotation_y_speed = 0.0
	def advance_time(self, proportion):
		self.add_mul_vector(proportion, self.speed)
		self.turn_y(self.rotation_y_speed * proportion)
		self.turn_x(self.rotation_x_speed * proportion)
camera = MovableCamera(scene)
camera.set_xyz(16.0, 6.0, 0.0)
camera.look_at(soya.Point(scene, 16.0, 6.0, 10.0))
soya.set_root_widget(camera)
scene.x = 100.0

#fog
scene.atmosphere = soya.Atmosphere()
scene.atmosphere.ambient = (1.0, 1.0, 1.0, 1.0)
scene.atmosphere.fog = 1
scene.atmosphere.fog_type = 0
scene.atmosphere.fog_start = 0.0
scene.atmosphere.fog_end = 50.0
scene.atmosphere.fog_color = (1.0, 1.0, 1.0, 1.0)
#scene.atmosphere.fog_color = (0.5, 0.5, 0.5, 1.0)

import soya.widget
soya.set_root_widget(soya.widget.Group())
soya.root_widget.add(camera)
soya.root_widget.add(soya.widget.FPSLabel())
m = soya.MainLoop(scene)
m.main_loop()
