import sys, os, os.path, soya, soya.sdlconst
soya.init()
soya.path.append(os.path.join(os.path.dirname(sys.argv[0]), "data"))
scene = soya.World()
class CaterpillarHead(soya.Body):
	def __init__(self, parent):
		soya.Body.__init__(self, parent, soya.Model.get("caterpillar_head"))
		self.speed             = soya.Vector(self, 0.0, 0.0, 0.0)
		self.rotation_y_speed  = 0.0
		self.mouse_x           = 0
		self.mouse_y           = 0
	def begin_round(self):
		soya.Body.begin_round(self)
		for event in soya.process_event():
			if event[0] == soya.sdlconst.MOUSEMOTION:
				self.mouse_x = event[1]
				self.mouse_y = event[2]
		mouse_pos = camera.coord2d_to_3d(self.mouse_x, self.mouse_y, (self % camera).z)
		mouse_pos.convert_to(scene)
		mouse_pos.y = 0.0
		self.speed.z = -self.distance_to(mouse_pos)
		self.look_at(mouse_pos)
	def advance_time(self, proportion):
		soya.Body.advance_time(self, proportion)
		self.add_mul_vector(proportion, self.speed)
class CaterpillarPiece(soya.Body):
	def __init__(self, parent, previous):
		soya.Body.__init__(self, parent, soya.Model.get("caterpillar"))
		self.previous = previous
		self.speed = soya.Vector(self, 0.0, 0.0, -0.2)
	def begin_round(self):
		soya.Body.begin_round(self)
		previous_next_pos = self.previous + self.previous.speed
		self.look_at(previous_next_pos)
		self.speed.z = -(self.distance_to(previous_next_pos) - 1.5)
	def advance_time(self, proportion):
		soya.Body.advance_time(self, proportion)
		self.add_mul_vector(proportion, self.speed)
caterpillar_head = CaterpillarHead(scene)
caterpillar_head.rotate_y(90.0)
previous_caterpillar_piece = caterpillar_head
for i in range(10):
	previous_caterpillar_piece = CaterpillarPiece(scene, previous_caterpillar_piece)
	previous_caterpillar_piece.x = i + 1
light = soya.Light(scene)
light.set_xyz(2.0, 5.0, 1.0)
camera = soya.Camera(scene)
camera.set_xyz(0.0, 15.0, 15.0)
camera.look_at(caterpillar_head)
soya.set_root_widget(camera)
soya.MainLoop(scene).main_loop()
