import sys, os, os.path, soya, soya.cube
soya.init()
soya.path.append(os.path.join(os.path.dirname(sys.argv[0]), "data"))
scene = soya.World()
sword = soya.World.get("sword")
model_builder = soya.SimpleModelBuilder()
model_builder.shadow = 1
sword.model_builder = model_builder
sword_model = sword.to_model()
class RotatingBody(soya.Body):
	def __init__(self, parent = None, model = None):
		soya.Body.__init__(self, parent, model)
	def advance_time(self, proportion):
		soya.Body.advance_time(self, proportion)
		self.rotate_y(proportion * 2.0)
body = RotatingBody(scene, sword_model)
body.set_xyz(1.0, -1.0, 0.0)
body.rotate_x(90.0)
wall_model = soya.World()
wall_face = soya.Face(wall_model, [
	soya.Vertex(wall_model, 0.0, -5.0, -5.0),
	soya.Vertex(wall_model, 0.0, -5.0,  5.0),
	soya.Vertex(wall_model, 0.0,  5.0,  5.0),
	soya.Vertex(wall_model, 0.0,  5.0, -5.0),
	])
wall_face.double_sided = 1
wall = soya.Body(scene, wall_model.to_model())
wall.set_xyz(-1.0, 0.0, 0.0)
light = soya.Light(scene)
light.set_xyz(5.0, 0.0, 0.0)
light.shadow_color = (0.0, 0.0, 0.0, 0.5)
light.cast_shadow = 1
camera = soya.Camera(scene)
camera.set_xyz(0.0, 0.0, 3.5)
soya.set_root_widget(camera)
soya.MainLoop(scene).main_loop()
