import sys, os
from random import choice, gauss as normalvariate, randint, random, expovariate
import soya
import soya.widget
from soya import Vector

soya.init("Terrain and ODE",width=1024,height=768)
soya.path.append(os.path.join(os.path.dirname(sys.argv[0]), "data"))
scene = soya.World()

terrain = soya.Terrain(scene)
print "setting terrain's image"
terrain.from_image(soya.Image.get("map3.png"))

print "multiplying height"
terrain_height =  150.
terrain.multiply_height(terrain_height)

terrain.texture_factor = 1.0

terrain.scale_factor   = 1.0
terrain.split_factor   = 2.0
terrain.geom = True
print 'terrain.geom :',terrain.geom

scene.gravity = soya.Vector(scene,0,-19,0)

light = soya.Light(scene)
light.set_xyz(100,70,100)

main = soya.widget.Group()

camera = soya.Camera(scene)
camera.set_xyz(125, 110,100)
camera.look_at(soya.Point(scene,0,50,35))
camera.back = 300

main.add(camera)

soya.set_root_widget(main)
soya.MainLoop(scene).main_loop()
