import sys, os
from random import choice, gauss as normalvariate, randint, random, expovariate
import soya
import soya.widget
from soya import Vector

soya.init("Terrain and ODE",width=1024,height=768)
soya.path.append(os.path.join(os.path.dirname(sys.argv[0]), "data"))
scene = soya.World()

terrain = soya.Terrain(scene)
print "setting terrain's image"
terrain.from_image(soya.Image.get("map3.png"))

print "multiplying height"
terrain_height =  100.
terrain.multiply_height(terrain_height)

ground = soya.Material(soya.Image.get("ground.png"))
grass  = soya.Material(soya.Image.get("grass.png"))
terrain.set_material_layer(ground, 0.0, 5*terrain_height/12.)
terrain.set_material_layer(grass, 5*terrain_height/12.0, 7*terrain_height/12.)

terrain.texture_factor = 1.0

terrain.scale_factor   = 1.0
terrain.split_factor   = 2.0
terrain.geom = True
print 'terrain.geom :',terrain.geom

class Head(soya.Body):
	model = soya.Model.get("caterpillar_head")
	def __init__(self,parent):
		soya.Body.__init__(self,parent, self.model)
		self.mass = soya.SphericalMass(12,1,"total_mass")
 		self.geom = soya.GeomSphere(self,1.2)

head_a = Head(scene)
head_a.set_xyz(77, terrain_height, 20)

scene.gravity = soya.Vector(scene,0,-19,0)

light = soya.Light(scene)
light.set_xyz(100,70,100)

main = soya.widget.Group()

camera = soya.Camera(scene)
camera.set_xyz(125, 110,100)
camera.look_at(soya.Point(scene,0,50,35))
camera.back = 300

main.add(camera)

soya.set_root_widget(main)
soya.MainLoop(scene).main_loop()
