# -*- indent-tabs-mode: t -*-

# Soya 3D tutorial
# Copyright (C) 2007-2008 Patrick Sabin
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import sys, os, os.path, soya
import soya.sphere, soya.cube

soya.init()
soya.path.append(os.path.join(os.path.dirname(sys.argv[0]), "data"))

scene = soya.World()

# Use the Soya cube and sphere

m_sphere = soya.sphere.Sphere(None,None).shapify()
m_cube = soya.cube.Cube(None, None,size=3).shapify()

sphere=soya.Body(scene,m_sphere)
cube=soya.Body(scene,m_cube)

cube.set_xyz(5,0,0)

light = soya.Light(scene)
light.set_xyz(13.0, 0.7, 30)

camera = soya.Camera(scene)
camera.set_xyz(8, 8, 8)
camera.look_at(sphere)
soya.set_root_widget(camera)

soya.MainLoop(scene).main_loop()

