#Shading
import sys, os, os.path, soya
soya.init()
soya.path.append(os.path.join(os.path.dirname(sys.argv[0]), "data"))
scene = soya.World()
scene.atmosphere = soya.Atmosphere()
scene.atmosphere.bg_color = (1.0, 1.0, 1.0, 1.0)
sword = soya.World.get("sword")

#Material
material = sword.children[0].material
material.texture = soya.Image.get("epee_turyle-cs.png")
#material.separate_specular = 1
#material.shininess = 0.0
#material.specular = (0.0, 0.0, 1.0, 1.0)
sword_model = sword.to_model()
shader = soya.Material()
shader.texture = soya.Image.get("shader.png")
celshading = soya.CellShadingModelBuilder()
celshading.shader              = shader
#celshading.outline_color       = (0.0, 0.0, 0.0, 1.0)
#celshading.outline_width       = 7.0
#celshading.outline_attenuation = 1.0
sword.model_builder = celshading
sword_celshaded_model = sword.to_model()


class RotatingBody(soya.Body):
	def __init__(self, parent = None, model = None, sens = 1.0):
		soya.Body.__init__(self, parent, model)
		self.sens = sens
	def advance_time(self, proportion):
		soya.Body.advance_time(self, proportion)
		self.rotate_y(proportion * 2.0 * self.sens)
body1 = RotatingBody(scene, sword_model)
body1.set_xyz(-1.0, 0.0, 0.0)
body1.rotate_x(90.0)
body2 = RotatingBody(scene, sword_celshaded_model, -1)
body2.set_xyz( 1.0, 0.0, 0.0)
body2.rotate_x(90.0)
light = soya.Light(scene)
light.set_xyz(0.0, 1.0, 1.0)
camera = soya.Camera(scene)
camera.set_xyz(0.0, 0.8, 2.5)
soya.set_root_widget(camera)
soya.MainLoop(scene).main_loop()
