import os, os.path, sys
import soya, soya.sdlconst, soya.cube as cube
soya.init(sound = 1)
soya.set_sound_volume(1.0)
soya.path.append(os.path.join(os.path.dirname(sys.argv[0]), "data"))
scene = soya.World()
camera = soya.Camera(scene)
camera.set_xyz(0.0, 0.0, 0.0)
soya.set_root_widget(camera)
camera.listen_sound = 1
import math
class NoisyCube(soya.World):
	def __init__(self, parent, model):
		soya.World.__init__(self, parent, model)
		self.speed             = soya.Vector(self, 0.0, 0.0, 0.0)
		self.rotation_y_speed  = 0.0
		self.mouse_x           = 0
		self.mouse_y           = 0
	def begin_round(self):
		#print event[0]
		soya.World.begin_round(self)
		for event in soya.process_event():
			if event[0] == soya.sdlconst.MOUSEMOTION:
				self.mouse_x = event[1]
				self.mouse_y = event[2]
		mouse_pos = camera.coord2d_to_3d(self.mouse_x, self.mouse_y, (self % camera).z)
		mouse_pos.convert_to(scene)
		mouse_pos.y = 0.0
		self.speed.z = -self.distance_to(mouse_pos)
		self.look_at(mouse_pos)
	def advance_time(self, proportion):
		soya.World.advance_time(self, proportion)
		self.add_mul_vector(proportion, self.speed)
	def ended(self):
		print "ended"
cube = NoisyCube(scene, cube.Cube().to_model())
cube.set_xyz(0,0,-3.0)
sound = soya.Sound.get("test.wav")
sound_player = soya.SoundPlayer(cube, sound, loop = 1)
light = soya.Light(scene)
light.set_xyz(1.5, 2.0, 2.2)
soya.MainLoop(scene).main_loop()
